#include <windows.h>
LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
HINSTANCE hInstance;
COLORREF bk_color;
int WINAPI wWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
PWSTR lpCmdLine, int nCmdShow) {
HWND hwnd;
MSG msg ; 
WNDCLASS wc = {0};
wc.lpszClassName = TEXT("GroupBox");
wc.hInstance = hInstance;
wc.hbrBackground = GetSysColorBrush(COLOR_3DFACE);
wc.lpfnWndProc = WndProc;
wc.hCursor = LoadCursor(0, IDC_ARROW);
hInstance = hInstance;
RegisterClass(&wc);
hwnd = CreateWindow(wc.lpszClassName, TEXT("API Mapping Mode"),WS_OVERLAPPEDWINDOW | WS_VISIBLE,100, 100, 600, 350, 0, 0, hInstance, 0); 
while( GetMessage(&msg, NULL, 0, 0)) {
DispatchMessage(&msg);
}
return (int) msg.wParam;
}
LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, 
WPARAM wParam, LPARAM lParam) {
HDC dc;
PAINTSTRUCT ps;

switch(msg) {
case WM_PAINT:
dc = BeginPaint(hwnd, &ps);
RECT rect; 
GetClientRect (hwnd,&rect);
//draw rectangle with default pen
Rectangle (dc,100, 100, 300, 300); 
//draw rectangle with red pen using mapping mode MM_HIMETRIC
HPEN linecolour;
linecolour=CreatePen(PS_SOLID,1,RGB(255, 0, 0));
SelectObject(dc,linecolour);
SetMapMode (dc,MM_HIMETRIC); 
Rectangle (dc,100, -100, 300, -300);
DeleteObject(linecolour);
//draw rectangle with blue pen using mapping mode MM_LOMETRIC
HPEN linecolour1;
linecolour1=CreatePen(PS_SOLID,1,RGB(0, 0, 255));
SelectObject(dc,linecolour1);
SetMapMode (dc,MM_LOMETRIC); 
Rectangle (dc,100, -100, 300, -300);
DeleteObject(linecolour1);
//draw rectangle with purple pen using mapping mode MM_LOENGLISH
HPEN linecolour2;
linecolour2=CreatePen(PS_SOLID,1,RGB(255, 0, 255));
SetMapMode (dc,MM_LOENGLISH);
SelectObject(dc,linecolour2);
Rectangle (dc,100, -100, 300, -300);
DeleteObject(linecolour2);
//draw rectangle with blue pen using and PS_DASH pen style using mapping mode MM_ANISOTROPIC
SetMapMode (dc,MM_ANISOTROPIC); 
SetWindowExtEx (dc,1, 10,NULL);
SetViewportExtEx (dc,1,1,NULL); 
HPEN linecolour3;
linecolour3=CreatePen(PS_DASH,1,RGB(0, 0, 255));
SelectObject(dc,linecolour3);
Rectangle (dc,100, 300, 300, 500);
DeleteObject(linecolour3);
EndPaint(hwnd, &ps);
break;
case WM_DESTROY:
PostQuitMessage(0);
break; 
}
return DefWindowProc(hwnd, msg, wParam, lParam);
}